var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import ajax from './utils/ajax';
import { unix, blobToBuffer, filterOptions, getContentMd5, getSignature } from './utils';
var TinyAliOSS = /** @class */ (function () {
    function TinyAliOSS(options) {
        if (options === void 0) { options = {}; }
        this.host = '';
        this.opts = {};
        filterOptions(options);
        this.opts = Object.assign({
            region: 'oss-cn-hangzhou',
            internal: false,
            cname: false,
            secure: false,
            timeout: 60000
        }, options);
        var _a = this.opts, bucket = _a.bucket, region = _a.region, endpoint = _a.endpoint, internal = _a.internal;
        this.host = '';
        if (endpoint) {
            this.host = endpoint;
        }
        else {
            var host = bucket;
            if (internal) {
                host += '-internal';
            }
            host += "." + region + ".aliyuncs.com";
            this.host = host + '';
        }
    }
    TinyAliOSS.prototype.put = function (objectName, file, options) {
        var _this = this;
        if (options === void 0) { options = {}; }
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var buf, _a, accessKeyId, accessKeySecret, stsToken, bucket, policy, verb, contentMd5, contentType, headers, signature, protocol, url, result, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, blobToBuffer(file)];
                    case 1:
                        buf = _b.sent();
                        _a = this.opts, accessKeyId = _a.accessKeyId, accessKeySecret = _a.accessKeySecret, stsToken = _a.stsToken, bucket = _a.bucket, policy = _a.policy;
                        verb = 'PUT';
                        contentMd5 = getContentMd5(buf);
                        contentType = file.type;
                        headers = {
                            'Content-Md5': contentMd5,
                            'Content-Type': contentType,
                            'x-oss-date': new Date().toUTCString()
                        };
                        if (stsToken) {
                            headers['x-oss-security-token'] = stsToken;
                        }
                        if (!policy) {
                            signature = getSignature({
                                verb: verb,
                                contentMd5: contentMd5,
                                headers: headers,
                                bucket: bucket,
                                objectName: objectName,
                                accessKeyId: accessKeyId,
                                accessKeySecret: accessKeySecret
                            });
                            headers.Authorization = "OSS " + accessKeyId + ":" + signature;
                        }
                        protocol = this.opts.secure ? 'https' : 'http';
                        url = protocol + "://" + this.host + "/" + objectName;
                        result = ajax(url, {
                            method: verb,
                            headers: headers,
                            data: file,
                            xhrInit: options.xhrInit,
                            timeout: this.opts.timeout || 60e3,
                            progress: options.progress
                        });
                        resolve(result);
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _b.sent();
                        reject(error_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); });
    };
    // https://help.aliyun.com/document_detail/45126.html
    TinyAliOSS.prototype.putSymlink = function (name, targetName) {
        var _a = this.opts, accessKeyId = _a.accessKeyId, accessKeySecret = _a.accessKeySecret, stsToken = _a.stsToken, bucket = _a.bucket;
        var verb = 'PUT';
        var headers = {
            'x-oss-date': new Date().toUTCString(),
            'x-oss-symlink-target': encodeURI(targetName)
        };
        if (stsToken) {
            headers['x-oss-security-token'] = stsToken;
        }
        var signature = getSignature({
            verb: verb,
            headers: headers,
            bucket: bucket,
            objectName: name,
            accessKeyId: accessKeyId,
            accessKeySecret: accessKeySecret,
            subResource: {
                symlink: ''
            }
        });
        headers.Authorization = "OSS " + accessKeyId + ":" + signature;
        var protocol = this.opts.secure ? 'https' : 'http';
        var url = protocol + "://" + this.host + "/" + name + "?symlink";
        return ajax(url, {
            method: verb,
            headers: headers,
            timeout: this.opts.timeout
        });
    };
    TinyAliOSS.prototype.signatureUrl = function (objectName, options) {
        if (options === void 0) { options = {}; }
        var _a = options.expires, expires = _a === void 0 ? 1800 : _a, method = options.method, process = options.process, response = options.response;
        var _b = this.opts, accessKeyId = _b.accessKeyId, accessKeySecret = _b.accessKeySecret, stsToken = _b.stsToken, bucket = _b.bucket;
        var headers = {};
        var subResource = {};
        if (process) {
            var processKeyword = 'x-oss-process';
            subResource[processKeyword] = process;
        }
        if (response) {
            Object.keys(response).forEach(function (k) {
                var key = "response-" + k.toLowerCase();
                subResource[key] = response[k];
            });
        }
        Object.keys(options).forEach(function (key) {
            var lowerKey = key.toLowerCase();
            var value = options[key];
            if (lowerKey.indexOf('x-oss-') === 0) {
                headers[lowerKey] = value;
            }
            else if (lowerKey.indexOf('content-md5') === 0) {
                headers[key] = value;
            }
            else if (lowerKey.indexOf('content-type') === 0) {
                headers[key] = value;
            }
            else if (lowerKey !== 'expires' && lowerKey !== 'response' && lowerKey !== 'process' && lowerKey !== 'method') {
                subResource[lowerKey] = value;
            }
        });
        var securityToken = options['security-token'] || stsToken;
        if (securityToken) {
            subResource['security-token'] = securityToken;
        }
        var expireUnix = unix() + expires;
        var signature = getSignature({
            type: 'url',
            verb: method || 'GET',
            accessKeyId: accessKeyId,
            accessKeySecret: accessKeySecret,
            bucket: bucket,
            objectName: objectName,
            headers: headers,
            subResource: subResource,
            expires: expireUnix
        });
        var protocol = this.opts.secure ? 'https' : 'http';
        var url = protocol + "://" + this.host + "/" + objectName;
        url += "?OSSAccessKeyId=" + accessKeyId;
        url += "&Expires=" + expireUnix;
        url += "&Signature=" + encodeURIComponent(signature);
        Object.keys(subResource).forEach(function (k) {
            url += "&" + k + "=" + encodeURIComponent(subResource[k]);
        });
        return url;
    };
    return TinyAliOSS;
}());
export default TinyAliOSS;
//# sourceMappingURL=index.js.map