export default function ajax(url, options) {
    if (options === void 0) { options = {}; }
    return new Promise(function (resolve, reject) {
        var _a = options.data, data = _a === void 0 ? null : _a, _b = options.headers, headers = _b === void 0 ? {} : _b, _c = options.method, method = _c === void 0 ? 'get' : _c, _d = options.timeout, timeout = _d === void 0 ? 0 : _d, progress = options.progress;
        var xhr = new XMLHttpRequest();
        var timerId = 0;
        if (timeout) {
            timerId = window.setTimeout(function () {
                reject(new Error("the request timeout " + timeout + "ms"));
            }, timeout);
        }
        xhr.onerror = function () {
            reject(new Error('unknown error'));
        };
        if (progress) {
            var onprogress_1 = function (event) {
                progress(Number(((event.loaded / event.total) * 100).toFixed(2)));
            };
            if (xhr.upload) {
                // Note: the progress event must be located before the xhr.open method
                xhr.upload.onprogress = onprogress_1;
            }
            xhr.onprogress = onprogress_1;
        }
        Promise.resolve().then(function () {
            if (options.xhrInit) {
                options.xhrInit(xhr, xhr.abort.bind(xhr));
            }
        });
        xhr.onreadystatechange = function () {
            if (xhr.readyState === 4) {
                if (timeout)
                    clearTimeout(timerId);
                if (xhr.status >= 200 && xhr.status < 300) {
                    resolve({ data: xhr.response });
                }
                else {
                    if (xhr.status !== 0) {
                        var err = new Error('the request is error');
                        reject(err);
                    }
                }
            }
        };
        xhr.open(method, url, true);
        Object.keys(headers).forEach(function (key) {
            xhr.setRequestHeader(key, headers[key]);
        });
        try {
            xhr.send(data);
        }
        catch (err) {
            reject(err);
        }
    });
}
//# sourceMappingURL=ajax.js.map